 /*
  * UAE - The Un*x Amiga Emulator
  *
  * Unix file system handler for AmigaDOS
  *
  * Copyright 1997 Bernd Schmidt
  */

struct hardfiledata {
    unsigned long size;
    int nrcyls;
    int secspertrack;
    int surfaces;
    int reservedblocks;
    int blocksize;
    int fd; // used for I/O, only open if media is inserted
    int isatapi; // -1: unknown, 0 = false, 1 = true
    struct _UnitInfo *unitinfo;
};

typedef struct _UnitInfo
{
    char *devname; /* device name, e.g. UAE0: */
    uaecptr devname_amiga;
    uaecptr startup;
    char *volname; /* volume name, e.g. CDROM, WORK, etc. */
    char *rootdir; /* root unix directory */
    int readonly; /* disallow write access? */
    int devno;

    struct hardfiledata hf;

    /* Threading stuff */
    smp_comm_pipe *unit_pipe, *back_pipe;
    penguin_id tid;
    struct _unit *volatile self;
    /* Reset handling */
    sem_t reset_sync_sem;
    int reset_state;
} UnitInfo;

struct uaedev_mount_info;

extern struct hardfiledata *get_hardfile_data (int nr);
