#ifndef NATIVELIB_H
#define NATIVELIB_H

#define NATIVE_CREATECONTEXT    1
#define NATIVE_DESTROYCONTEXT   2
#define NATIVE_OPENOBJECT       3
#define NATIVE_CLOSEOBJECT      4
#define NATIVE_GETSYMBOLID      5
#define NATIVE_CALLFUNCTION     6
#define NATIVE_SIGNAL           7
#define NATIVE_SHUTDOWN         8


struct NativeSymbol
{
	struct NativeObject *object;
	const char *symbolName;
	ULONG symbolID;
};


struct NativeCall
{
	struct NativeObject *object;
	ULONG symbolID;
	VOID *args;
	ULONG retval;
};


struct NativeSignal
{
	struct NativeObject *object;
	int posix_signo;
};


void nativelib_install(void);
void nativelib_exit(void);
void nativelib_reset(void);


#endif	/* NATIVELIB_H */
