 /*
  * UAE - The Un*x Amiga Emulator
  *
  * Joystick emulation stubs
  *
  * Copyright 1997 Bernd Schmidt
  */

#include "sysconfig.h"
#include "sysdeps.h"

#include "config.h"
#include "options.h"
#include "memory.h"
#include "custom.h"
#include "joystick.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "../joystickdriver/dcmd_axljs.h"

//int joy1_button1, joy1_button2, joy1_bot, joy1_right, joy1_top, joy1_left;
int nr_joysticks;

static int devfd = -1;
static struct AXLJoyDat joydat;

void read_joystick(int nr, unsigned int *dir, int *button)
{
    int b, t;
	int joy_bot, joy_top, joy_left, joy_right;

    *dir = 0;
    *button = 0;

    if (nr >= nr_joysticks
    ||  read(devfd, &joydat, sizeof(joydat)) != sizeof(joydat))
    	return;

	joy_bot = (joydat.yaxis > 0) ? 1 : 0;
	joy_top = (joydat.yaxis < 0) ? 1 : 0;
	joy_left  = (joydat.xaxis < 0) ? 1 : 0;
	joy_right = (joydat.xaxis > 0) ? 1 : 0;

	if (joy_right)
		b = !joy_bot;
	else
		b = joy_bot;
	if (joy_left)
		t = !joy_top;
	else
		t = joy_top;

	*button = (joydat.but1) | (joydat.but2 << 1);
	*dir = b | (joy_right << 1) | (t << 8) | (joy_left << 9);
}

void init_joystick(void)
{
	devfd = open("/usr/amiga/dev/axljs", O_RDONLY);
	if(devfd < 0)
	{
		printf("Failed to open joystick driver.\n");
	    nr_joysticks = 0;
	}
	else
	{
    	nr_joysticks = 1;
    }
}


void close_joystick(void)
{
	if(devfd >= 0)
		close(devfd);
	devfd = -1;
}

