
#include "screenbar.h"

#include <Pt.h>
#include <Ph.h>
#include <stdio.h>
#include <stdarg.h>

#define Pt_ARG_DONE 0
#define EVENTSIZE (sizeof(PhEvent_t) + 2048)


static char upImg14[] =
"WWWWWWWWWWWWWWWWWWWWWWW"
"W                     B"
"W                     B"
"W   BBBBBBBBBBB       B"
"W   B         B       B"
"W   B   BBBBBBBBBBB   B"
"W   B   BWWWWWWWWWB   B"
"W   B   BWWWWWWWWWB   B"
"W   BBBBBWWWWWWWWWB   B"
"W       BWWWWWWWWWB   B"
"W       BBBBBBBBBBB   B"
"W                     B"
"W                     B"
"BBBBBBBBBBBBBBBBBBBBBBB";


static char dwImg14[] =
"BBBBBBBBBBBBBBBBBBBBBBB"
"B                     W"
"B                     W"
"B   BBBBBBBBBBB       W"
"B   B         B       W"
"B   B   BBBBBBBBBBB   W"
"B   B   BWWWWWBWWWB   W"
"B   B   BWWWWWBWWWB   W"
"B   BBBBBBBBBBBWWWB   W"
"B       BWWWWWWWWWB   W"
"B       BBBBBBBBBBB   W"
"B                     W"
"B                     W"
"WWWWWWWWWWWWWWWWWWWWWWW";


static char upImg16[] =
"WWWWWWWWWWWWWWWWWWWWWWW"
"W                     B"
"W                     B"
"W   BBBBBBBBBBB       B"
"W   B         B       B"
"W   B   BBBBBBBBBBB   B"
"W   B   BWWWWWWWWWB   B"
"W   B   BWWWWWWWWWB   B"
"W   B   BWWWWWWWWWB   B"
"W   B   BWWWWWWWWWB   B"
"W   BBBBBWWWWWWWWWB   B"
"W       BWWWWWWWWWB   B"
"W       BBBBBBBBBBB   B"
"W                     B"
"W                     B"
"BBBBBBBBBBBBBBBBBBBBBBB";


static char dwImg16[] =
"BBBBBBBBBBBBBBBBBBBBBBB"
"B                     W"
"B                     W"
"B   BBBBBBBBBBB       W"
"B   B         B       W"
"B   B   BBBBBBBBBBB   W"
"B   B   BWWWWWBWWWB   W"
"B   B   BWWWWWBWWWB   W"
"B   B   BWWWWWBWWWB   W"
"B   B   BWWWWWBWWWB   W"
"B   BBBBBBBBBBBWWWB   W"
"B       BWWWWWWWWWB   W"
"B       BBBBBBBBBBB   W"
"B                     W"
"B                     W"
"WWWWWWWWWWWWWWWWWWWWWWW";


static char upImg18[] =
"WWWWWWWWWWWWWWWWWWWWWWW"
"W                     B"
"W                     B"
"W                     B"
"W   BBBBBBBBBBB       B"
"W   B         B       B"
"W   B   BBBBBBBBBBB   B"
"W   B   BWWWWWWWWWB   B"
"W   B   BWWWWWWWWWB   B"
"W   B   BWWWWWWWWWB   B"
"W   B   BWWWWWWWWWB   B"
"W   BBBBBWWWWWWWWWB   B"
"W       BWWWWWWWWWB   B"
"W       BBBBBBBBBBB   B"
"W                     B"
"W                     B"
"W                     B"
"BBBBBBBBBBBBBBBBBBBBBBB";


static char dwImg18[] =
"BBBBBBBBBBBBBBBBBBBBBBB"
"B                     W"
"B                     W"
"B                     W"
"B   BBBBBBBBBBB       W"
"B   B         B       W"
"B   B   BBBBBBBBBBB   W"
"B   B   BWWWWWBWWWB   W"
"B   B   BWWWWWBWWWB   W"
"B   B   BWWWWWBWWWB   W"
"B   B   BWWWWWBWWWB   W"
"B   BBBBBBBBBBBWWWB   W"
"B       BWWWWWWWWWB   W"
"B       BBBBBBBBBBB   W"
"B                     W"
"B                     W"
"B                     W"
"WWWWWWWWWWWWWWWWWWWWWWW";

static PtWidget_t *window = NULL;
static int oldWorkspaceWidth;
int qnxWorkspaceToBackPressed = 0;


static PtWidget_t *PtCreateWidgetArgs(PtWidgetClassRef_t *wclass, PtWidget_t *parent, long argtype, ...)
{
	va_list vl;
	int argcnt = 0;
	PtArg_t args[50];

	va_start(vl, parent);
	while(argcnt < 50)
	{
		long t, v, l;
		t = va_arg(vl, long);
		if(t == Pt_ARG_DONE)
			break;
		v = va_arg(vl, long);
		l = va_arg(vl, long);
		PtSetArg(&args[argcnt], t, v, l);
		argcnt ++;
	}
	va_end(vl);
	return PtCreateWidget(wclass, parent, argcnt, args);
}


static PhImage_t *createImage(char *asciisrc, int width, int height)
{
	PhImage_t *image;
	PgColor_t palette[128] = { 0 };

	palette['W'] = Pg_WHITE;
	palette['w'] = Pg_WHITE;
	palette['B'] = Pg_BLACK;
	palette['b'] = Pg_BLACK;
	palette[' '] = Pg_GRAY;

	image = PhCreateImage(NULL, width, height, Pg_IMAGE_PALETTE_BYTE, palette, 128, 0);
	if(image)
	{
		int x, y;
		char *walk = image->image;
		for(y=0; y<height; y++)
		{
			for(x=0; x<width; x++)
			{
				*walk++ = *asciisrc++;
			}
			walk += image->bpl - width;
		}
		PhMakeTransBitmap(image, Pg_GRAY);
	}
	return image;
}


static void drawF(PtWidget_t *w, PhTile_t *damage)
{
	PhRect_t canvas;
	PhPoint_t p;

	PtCalcCanvas(w, &canvas);

	PgSetFillColor(Pg_WHITE);
	PgDrawIRect(canvas.ul.x, canvas.ul.y, canvas.lr.x, canvas.lr.y - 1, Pg_DRAW_FILL);
	PgSetStrokeColor(Pg_BLACK);
	PgDrawILine(canvas.ul.x, canvas.lr.y, canvas.lr.x, canvas.lr.y);
	p.x = 5;
	p.y = canvas.lr.y - 3;
	PgSetTextColor(Pg_BLACK);
	PgSetFont("TitleFont08");
	PgDrawStringmx("QNX Workspace", &p);
	PgFlush();
}


static int activateC(PtWidget_t *w, void *userdata, PtCallbackInfo_t *info)
{
	if(info && info->reason == Pt_CB_ACTIVATE)
	{
		qnxWorkspaceToBackPressed = 1;
	}
	return Pt_CONTINUE;
}


/*************************************************************************/
int createQnxWorkspaceBar(void)
{
	PhDim_t dim;
	PhRect_t offs;
	PhArea_t area;
	PhPoint_t lpoints[2];
	PtWidget_t *temp;
	PhImage_t *image1 = NULL, *image2 = NULL;

	PhWindowQueryVisible(Ph_QUERY_WORKSPACE, 0, PhInputGroup(NULL), &offs);
	oldWorkspaceWidth = offs.lr.x - offs.ul.x + 1;

	area.pos.x = offs.ul.x;
	area.pos.y = offs.ul.y;
	area.size.w = offs.lr.x - offs.ul.x + 1;
	area.size.h = 14;
	dim.w = 320;
	dim.h = 14;
	window = PtCreateWidgetArgs(PtWindow, Pt_NO_PARENT,
		Pt_ARG_AREA, &area, 0,
		Pt_ARG_WINDOW_MANAGED_FLAGS, Pt_FALSE, ~0,
		Pt_ARG_WINDOW_MANAGED_FLAGS, Pt_TRUE, Ph_WM_CONSWITCH | Ph_WM_FOCUS,
		Pt_ARG_WINDOW_NOTIFY_FLAGS, Pt_FALSE, ~0,
		Pt_ARG_WINDOW_RENDER_FLAGS, Pt_FALSE, ~0,
		Pt_ARG_WINDOW_STATE, Pt_FALSE, ~0,
		Pt_ARG_WINDOW_TITLE, "AmigaOS XL", 0,
		Pt_ARG_MINIMUM_DIM, &dim, 0,
		//Pt_ARG_WINDOW_STATE, Pt_TRUE, Ph_WM_STATE_ISBACKDROP,
		Pt_ARG_DONE);
	if(!window)
	{
		fprintf(stderr, "Failed to create screenbar on QNX workspace.\n");
		return 0;
	}

	area.pos.x = 0;
	area.pos.y = 0;
	area.size.w = offs.lr.x - offs.ul.x - 22;
	area.size.h = 16;
	temp = PtCreateWidgetArgs(PtRaw, window,
		Pt_ARG_RAW_DRAW_F, drawF, 0,
		Pt_ARG_AREA, &area, 0,
		Pt_ARG_FILL_COLOR, Pg_TRANSPARENT, 0,
		Pt_ARG_BASIC_FLAGS, Pt_FALSE, ~0,
		Pt_ARG_MARGIN_WIDTH, 0, 0,
		Pt_ARG_MARGIN_HEIGHT, 0, 0,
		Pt_ARG_DONE);

	area.pos.x = offs.lr.x - offs.ul.x - 22;
	PtExtentWidget(temp);
	PtWidgetExtent(temp, &offs);

	if(offs.lr.y - offs.ul.y + 1 <= 14)
	{
		image1 = createImage(upImg14, 23, 14);
		image2 = createImage(dwImg14, 23, 14);
		area.pos.y = 0;
		area.size.w = 23;
		area.size.h = 14;
	}
	else if(offs.lr.y - offs.ul.y + 1 <= 16)
	{
		image1 = createImage(upImg16, 23, 16);
		image2 = createImage(dwImg16, 23, 16);
		area.pos.y = 0;
		area.size.w = 23;
		area.size.h = 16;
	}
	else
	{
		image1 = createImage(upImg18, 23, 18);
		image2 = createImage(dwImg18, 23, 18);
		area.pos.y = 0;
		area.size.w = 23;
		area.size.h = 18;
	}

	temp = PtCreateWidgetArgs(PtButton, window,
		Pt_ARG_AREA, &area, 0,
		Pt_ARG_BASIC_FLAGS, Pt_FALSE, ~0,
		Pt_ARG_FLAGS, Pt_FALSE, ~0,
		Pt_ARG_FLAGS, Pt_TRUE, Pt_SELECTABLE,
		Pt_ARG_LABEL_TYPE, Pt_IMAGE, 0,
		Pt_ARG_LABEL_IMAGE, image1, 0,
		Pt_ARG_ARM_IMAGE, image2, 0,
		Pt_ARG_MARGIN_WIDTH, 0, 0,
		Pt_ARG_MARGIN_HEIGHT, 0, 0,
		Pt_ARG_DONE);
	PtAddCallback(temp, Pt_CB_ACTIVATE, activateC, NULL);
	return 1;
}


void destroyQnxWorkspaceBar(void)
{
	if(window)
		PtDestroyWidget(window);
	window = NULL;
}


void openQnxWorkspaceBar(void)
{
	PhRect_t offs;

	PhWindowQueryVisible(Ph_QUERY_WORKSPACE, 0, PhInputGroup(NULL), &offs);
	if(oldWorkspaceWidth != offs.lr.x - offs.ul.x + 1)
	{
		destroyQnxWorkspaceBar();
		createQnxWorkspaceBar();
	}
	if(window)
		PtRealizeWidget(window);
}

void closeQnxWorkspaceBar(void)
{
	if(window)
		PtUnrealizeWidget(window);
}

