 /*
  * UAE - The Un*x Amiga Emulator
  *
  * Support for the ALSA audio interface
  *
  * Copyright 2001 HAAGE&PARTNER Computer GmbH
  */

#include "threaddep/penguin.h"

extern char *audio_buffers[4];
extern char *audio_buffer_walk;
extern int audio_buffer_size;
extern smp_comm_pipe audio_pipe;


static __inline__ void check_sound_buffers (void)
{
	if(audio_buffer_walk >= audio_buffers[0] + audio_buffer_size)
	{
		char *s;
		write_comm_pipe_pvoid(&audio_pipe, audio_buffers[0], 1);

		s = audio_buffers[0];
		audio_buffers[0] = audio_buffers[1];
		audio_buffers[1] = audio_buffers[2];
		audio_buffers[2] = s;

		audio_buffer_walk = audio_buffers[0];
	}
}

#define PUT_SOUND_BYTE(b) do { *audio_buffer_walk++ = (char)b; } while (0)
#define PUT_SOUND_WORD(b) do { *((short*)audio_buffer_walk)++ = (short)b; } while (0)
#define PUT_SOUND_BYTE_LEFT(b)  PUT_SOUND_BYTE(b)
#define PUT_SOUND_WORD_LEFT(b)  PUT_SOUND_WORD(b)
#define PUT_SOUND_BYTE_RIGHT(b) PUT_SOUND_BYTE(b)
#define PUT_SOUND_WORD_RIGHT(b) PUT_SOUND_WORD(b)
#define SOUND16_BASE_VAL 0
#define SOUND8_BASE_VAL 0

#define DEFAULT_SOUND_MINB 4096
#define DEFAULT_SOUND_MAXB 8192
#define DEFAULT_SOUND_BITS 16
#define DEFAULT_SOUND_FREQ 44100

#define HAVE_STEREO_SUPPORT

